
#include "../main.h"

void SetCharacter( int playerindex, int player )
{
	switch( player )
	{
		case PLAYER_MEGAMANX:
			Players[playerindex].Character=PLAYER_MEGAMANX;
			Players[playerindex].xpos=320;
			Players[playerindex].ypos=240;
			Players[playerindex].PlayerData=MegamanXData;
			break;

		case PLAYER_ZERO:
			Players[playerindex].Character=PLAYER_ZERO;
			Players[playerindex].xpos=50;
			Players[playerindex].ypos=100;
			Players[playerindex].PlayerData=ZeroData;
			break;

		case PLAYER_TESTGUY:
			Players[playerindex].Character=PLAYER_TESTGUY;
			Players[playerindex].xpos=50;
			Players[playerindex].ypos=100;
			Players[playerindex].PlayerData=MegamanXData;
			break;

		case PLAYER_KNUCKLES:
			Players[playerindex].Character=PLAYER_KNUCKLES;
			Players[playerindex].xpos=50;
			Players[playerindex].ypos=100;
			Players[playerindex].PlayerData=MegamanXData;
			break;
	}

}

int TouchingWall( int playerindex, int DirCheck )
{
	int RetCode=FALSE;
	//int width=(Players[playerindex].PlayerData.Width/2)-1;

	if ( DirCheck == LEFT )
	{
		if ( CollisionAt( playerindex, Players[playerindex].xpos-1, Players[playerindex].ypos ) )
			RetCode=TRUE;
	}

	if ( DirCheck == RIGHT )
	{
		if ( CollisionAt( playerindex, Players[playerindex].xpos+1, Players[playerindex].ypos ) )
			RetCode=TRUE;
	}

 	return RetCode;
}

void ChangePlayerAction( int playerindex, int Action, int resetanim )
{
	if ( Players[playerindex].CurrentAction!=Action )
	{
		if ( resetanim == TRUE )
		{
			Players[playerindex].AnimPos=0;
		    	Players[playerindex].CurrentFrame=0;
		}
		Players[playerindex].CurrentAction=Action;
	}
}

int InAir( int playerindex )
{
	int RetCode;

	if ( CollisionAt( playerindex, Players[playerindex].xpos, Players[playerindex].ypos+1 ) == TRUE )
		RetCode=FALSE;
	else
		RetCode=TRUE;

 	return RetCode;
}

int MovePlayer( int playerindex, int xpos, int ypos )
{
	// The return code. Not actually used..
	int retcode=TRUE;

	// Width and height modifiers.
	int width;
	int height;

	// If a collision does NOT occur at the new location, move player.
	if ( CollisionAt( playerindex, (Players[playerindex].xpos+xpos),
		(Players[playerindex].ypos+ypos) ) == FALSE )
	{
		// If xpos isn't off the map completely.
		if ( Players[playerindex].xpos+xpos >= 0 &&
				Players[playerindex].xpos+xpos < mapxsize*32 )
		{
			// Move the player.
			Players[playerindex].xpos+=xpos;
		}

		// If ypos is off the map.....
		if ( Players[playerindex].ypos+ypos >= 0 &&
				Players[playerindex].ypos+ypos < mapysize*32 )
		{
			// move player..
			Players[playerindex].ypos+=ypos;
		}
	}

	else
	{
		width=(Players[playerindex].PlayerData.Width/2);
		//height=(Players[playerindex].ypos-Players[playerindex].PlayerData.Height-1)%32;
		height=Players[playerindex].PlayerData.Height;

		// Right
		if ( xpos > 0 )
			Players[playerindex].xpos+=((31-(width-1))-(Players[playerindex].xpos%32));
		// left
		if ( xpos < 0 )
			Players[playerindex].xpos-=(Players[playerindex].xpos%32)-width;

		// Falling..
		if ( ypos > 0 )
			Players[playerindex].ypos+=(31)-(Players[playerindex].ypos%32);

		// Jumping.
		else if ( ypos < 0 )
			Players[playerindex].ypos-=((Players[playerindex].ypos-(height-1))%32);
			//((31)-(Players[playerindex].ypos%32))+height;
	}

	return retcode;
}

int CollisionAt( int playerindex, int xpos, int ypos )
{
	int retcode=FALSE;
	int i;

	// Check height.
	int height=Players[playerindex].PlayerData.Height;
	int width=(Players[playerindex].PlayerData.Width/2);

	// Check all tiles above coord you'd collide with.
	for ( i=0; i<height; i++ )
	{
		if ( SlopeTable[((ypos-i)/32)*mapxsize+(xpos/32)]==SLOPE_90 )
			retcode=TRUE;

		// Check left side..
		if ( SlopeTable[((ypos-i)/32)*mapxsize+((xpos-width)/32)]==SLOPE_90 )
			retcode=TRUE;

		// Check right side..
		if ( SlopeTable[((ypos-i)/32)*mapxsize+((xpos+(width-1))/32)]==SLOPE_90 )
			retcode=TRUE;
	}

	return retcode;
}
