/*
	Knuckles: Odyssey
	Written by Sirk Siggler

*/
#include "../main.h"

void UpdateKnucklesAnimation( int playerindex )
{
	switch ( Players[playerindex].CurrentAction )
	{
		case DOING_WALKING:
			UpdateAnim( KnucklesWalking, playerindex );
			break;

		case DOING_JUMPING:
			UpdateAnim( KnucklesJumping, playerindex );
			break;

		case DOING_SLIDEJUMPING:
			UpdateAnim( KnucklesSlideJumping, playerindex );
			break;

		case DOING_FALLING:
			UpdateAnim( KnucklesFalling, playerindex );
			break;

		case DOING_STANDING:
			UpdateAnim( KnucklesStanding, playerindex );
			break;

		case DOING_SLIDING:
			UpdateAnim( KnucklesSliding, playerindex );
			break;

		case DOING_DASHING:
			UpdateAnim( KnucklesDashing, playerindex );
			break;

		case DOING_DUCKING:
			UpdateAnim( KnucklesDucking, playerindex );
			break;
	}
}

void DrawKnuckles( int playerindex )
{
	switch ( Players[playerindex].CurrentAction )
	{
		case DOING_WALKING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSWalking, playerindex );
			else
				DrawFrame( KnucklesWalking, playerindex );
			break;

		case DOING_STANDING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSStanding, playerindex );
			else
				DrawFrame( KnucklesStanding, playerindex );
			break;

		case DOING_JUMPING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSJumping, playerindex );
			else
				DrawFrame( KnucklesJumping, playerindex );
			break;

		case DOING_SLIDEJUMPING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSSlideJumping, playerindex );
			else
				DrawFrame( KnucklesSlideJumping, playerindex );
			break;

		case DOING_FALLING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSFalling, playerindex );
			else
				DrawFrame( KnucklesFalling, playerindex );
			break;

		case DOING_DUCKING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSDucking, playerindex );
			else
				DrawFrame( KnucklesDucking, playerindex );
			break;

		case DOING_DASHING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSDashing, playerindex );
			else
				DrawFrame( KnucklesDashing, playerindex );
			break;

		case DOING_SLIDING:
			if ( Players[playerindex].Shooting==TRUE)
				DrawFrame( KnucklesSSliding, playerindex );
			else
				DrawFrame( KnucklesSliding, playerindex );
			break;
	}
}



