/*
	MegamanX: Odyssey
	Written by Sirk Siggler

*/
#include "../main.h"

// 8 way RPGish
void ProcessMegamanX2( int playerindex )
{
	int WalkSpeed=Players[playerindex].PlayerData.WalkSpeed;

	if ( Controls[DO_UP] )
		MovePlayer( playerindex, 0, -(WalkSpeed) );
	if ( Controls[DO_DOWN] )
		MovePlayer( playerindex, 0, WalkSpeed );
	if ( Controls[DO_LEFT] )
		MovePlayer( playerindex, -(WalkSpeed), 0 );
	if ( Controls[DO_RIGHT] )
		MovePlayer( playerindex, WalkSpeed, 0 );
}

void ProcessMegamanX3( int playerindex )
{
	if ( Controls[DO_UP] )
		cameray--;
	if ( Controls[DO_DOWN] )
		cameray++;
	if ( Controls[DO_LEFT] )
		camerax--;
	if ( Controls[DO_RIGHT] )
		camerax++;
}

void ProcessMegamanX( int playerindex )
{
	int WalkSpeed, FallSpeed, JumpSpeed;

	WalkSpeed=Players[playerindex].PlayerData.WalkSpeed;
	FallSpeed=Players[playerindex].PlayerData.FallSpeed;
	JumpSpeed=Players[playerindex].PlayerData.JumpSpeed;

	if ( key[KEY_D] )
	{
		textprintf( screen, font, 0, 72, makecol( 0, 0, 255 ), "Walkspeed: %i", WalkSpeed );
		readkey();
	}

	if ( Controls[DO_JUMP] == FALSE )
		Players[playerindex].JumpPressed=FALSE;
	if ( Controls[DO_DASH] == FALSE )
	{
		Players[playerindex].DashPressed=FALSE;
		Players[playerindex].DashPos=0;
	}

	/* If in air, when shouldn't be. */
	if ( InAir( playerindex ) == TRUE &&
		 ( Players[playerindex].CurrentAction == DOING_STANDING ||
		 Players[playerindex].CurrentAction == DOING_WALKING ||
		 Players[playerindex].CurrentAction == DOING_DUCKING ||
		 Players[playerindex].CurrentAction == DOING_DASHING ) )
	{
		Players[playerindex].CurrentAction=DOING_FALLING;
		Players[playerindex].JumpHeight=Players[playerindex].PlayerData.MaxJumpHeight;
	}

	if ( InAir( playerindex ) == TRUE )
	{
		Players[playerindex].DashPos=Players[playerindex].PlayerData.DashDistance;

		/* If not jumping, make fall */
		if ( (Players[playerindex].CurrentAction==DOING_JUMPING ||
			Players[playerindex].CurrentAction==DOING_SLIDEJUMPING ) &&
			Controls[DO_JUMP]==FALSE )
		{
			ChangePlayerAction( playerindex, DOING_FALLING, TRUE );
			Players[playerindex].JumpHeight=Players[playerindex].PlayerData.MaxJumpHeight;
		}

		/* Player is sliding, */
		if ( Players[playerindex].JumpHeight >= Players[playerindex].PlayerData.MaxJumpHeight )
		{
			if ( TouchingWall( playerindex, LEFT ) == TRUE && Controls[DO_LEFT] == TRUE )
			{
				MovePlayer( playerindex, 0, FallSpeed/2 );
				ChangePlayerAction( playerindex, DOING_SLIDING, TRUE );
			}
			else if ( TouchingWall( playerindex, RIGHT ) == TRUE && Controls[DO_RIGHT] == TRUE )
			{
				MovePlayer( playerindex, 0, FallSpeed/2 );
				ChangePlayerAction( playerindex, DOING_SLIDING, TRUE );
			}
			else
			{
				ChangePlayerAction( playerindex, DOING_FALLING, TRUE );
				MovePlayer( playerindex, 0, FallSpeed );
			}
		}

		/* Player is jumping.. move up! */
		if ( Players[playerindex].JumpHeight <
			Players[playerindex].PlayerData.MaxJumpHeight &&
			Players[playerindex].CurrentAction!=DOING_FALLING &&
			Controls[DO_JUMP] == TRUE )
		{
			MovePlayer( playerindex, 0, -(JumpSpeed) );
			Players[playerindex].JumpHeight++;
		}

		/* Moving in air? */
		if ( Controls[DO_RIGHT] == TRUE && Controls[DO_LEFT] == FALSE &&
			Players[playerindex].CurrentAction!=DOING_SLIDING )
		{
			if ( Players[playerindex].DashJump == TRUE )
				MovePlayer( playerindex, WalkSpeed*2, 0 );
			else
				MovePlayer( playerindex, WalkSpeed, 0 );
			Players[playerindex].Facing=RIGHT;
		}
		if ( Controls[DO_LEFT] )
		{
			if ( Players[playerindex].DashJump == TRUE )
				MovePlayer( playerindex, -(WalkSpeed*2), 0 );
			else
				MovePlayer( playerindex, -(WalkSpeed), 0 );
			Players[playerindex].Facing=LEFT;
		}
		/* Wall Jumping */
		if ( Controls[DO_JUMP] == TRUE && Players[playerindex].JumpPressed == FALSE )
		{
			if ( TouchingWall( playerindex, Players[playerindex].Facing) == TRUE )
			{
				Players[playerindex].JumpHeight=0;
				if ( Players[playerindex].Facing == LEFT )
					MovePlayer( playerindex, 1, -(JumpSpeed) );
				else
					MovePlayer( playerindex, -1, -(JumpSpeed) );

				ChangePlayerAction( playerindex, DOING_SLIDEJUMPING, TRUE );
				Players[playerindex].JumpPressed=TRUE;

				if ( Controls[DO_DASH] == TRUE && Players[playerindex].DashPressed == FALSE )
				{
					Players[playerindex].DashJump=TRUE;
					Players[playerindex].DashPos=Players[playerindex].PlayerData.DashDistance;
				}
				else Players[playerindex].DashJump=FALSE;
			}
		}

	}
	else if ( InAir( playerindex ) == FALSE )
	{
		/* Player dashing while standing still ? */
		if ( Controls[DO_DASH] == TRUE && Controls[DO_LEFT] == FALSE &&
			Controls[DO_RIGHT] == FALSE && Players[playerindex].DashPressed == FALSE )
		{
			if ( Players[playerindex].Facing == LEFT )
			{
				if ( Players[playerindex].DashPos<=Players[playerindex].PlayerData.DashDistance )
				{
					MovePlayer( playerindex, -(WalkSpeed*2), 0 );
					Players[playerindex].DashPos++;
					Players[playerindex].Facing=LEFT;
					ChangePlayerAction( playerindex, DOING_DASHING, TRUE );
				}
				else
				{
					Players[playerindex].DashPos=0;
					ChangePlayerAction( playerindex, DOING_STANDING, TRUE );
					Players[playerindex].DashPressed=TRUE;
				}
			}
			else if ( Players[playerindex].Facing == RIGHT )
			{
				if ( Players[playerindex].DashPos<=Players[playerindex].PlayerData.DashDistance )
				{
					MovePlayer( playerindex, WalkSpeed*2, 0 );
					Players[playerindex].DashPos++;
					Players[playerindex].Facing=RIGHT;
					ChangePlayerAction( playerindex, DOING_DASHING, TRUE );
				}
				else
				{
					Players[playerindex].DashPos=0;
					ChangePlayerAction( playerindex, DOING_STANDING, TRUE );
					Players[playerindex].DashPressed=TRUE;
				}
			}
		}

		/* Walking right ?*/
		else if ( Controls[DO_RIGHT] == TRUE && Controls[DO_LEFT] == FALSE )
		{
			if ( Controls[DO_DASH] == TRUE && Players[playerindex].DashPressed == FALSE )
			{
				if ( Players[playerindex].DashPos<=Players[playerindex].PlayerData.DashDistance )
				{
					MovePlayer( playerindex, WalkSpeed*2, 0 );
					Players[playerindex].DashPos++;
					Players[playerindex].Facing=RIGHT;
					ChangePlayerAction( playerindex, DOING_DASHING, TRUE );
				}
				else
				{
					Players[playerindex].DashPos=0;
					Players[playerindex].DashPressed=TRUE;
				}
			}
			else
			{
				MovePlayer( playerindex, WalkSpeed, 0 );
				Players[playerindex].Facing=RIGHT;

				if ( TouchingWall( playerindex, LEFT ) == TRUE ||
						TouchingWall( playerindex, RIGHT ) == TRUE )
					ChangePlayerAction( playerindex, DOING_STANDING, TRUE );
				else
					ChangePlayerAction( playerindex, DOING_WALKING, TRUE );
			}
		}
		/* Walking left. */
		else if ( Controls[DO_LEFT] == TRUE && Controls[DO_RIGHT] == FALSE )
		{
			if ( Controls[DO_DASH] == TRUE && Players[playerindex].DashPressed == FALSE )
			{
				if ( Players[playerindex].DashPos<=Players[playerindex].PlayerData.DashDistance )
				{
					MovePlayer( playerindex, -(WalkSpeed*2), 0 );
					Players[playerindex].DashPos++;
					Players[playerindex].Facing=LEFT;
					ChangePlayerAction( playerindex, DOING_DASHING, TRUE );
				}
				else
				{
					Players[playerindex].DashPos=0;
					Players[playerindex].DashPressed=TRUE;
				}
			}
			else
			{
				MovePlayer( playerindex, -(WalkSpeed), 0 );
				Players[playerindex].Facing=LEFT;

				if ( TouchingWall( playerindex, LEFT ) == TRUE ||
						TouchingWall( playerindex, RIGHT ) == TRUE )
					ChangePlayerAction( playerindex, DOING_STANDING, TRUE );
				else
					ChangePlayerAction( playerindex, DOING_WALKING, TRUE );
			}
		}
		/* Player ducking */
		else if ( Controls[DO_DOWN] == TRUE )
		{
			ChangePlayerAction( playerindex, DOING_DUCKING, TRUE );
		}
		else
			ChangePlayerAction( playerindex, DOING_STANDING, TRUE );

		/* Jumping ? */
		if ( Controls[DO_JUMP] && Players[playerindex].JumpPressed == FALSE )
		{
			Players[playerindex].JumpHeight=0;
			MovePlayer( playerindex, 0, -(JumpSpeed) );
			ChangePlayerAction( playerindex, DOING_JUMPING, TRUE );
			Players[playerindex].JumpPressed=TRUE;

			if ( Controls[DO_DASH] == TRUE && Players[playerindex].DashPressed == FALSE )
			{
				Players[playerindex].DashJump=TRUE;
				Players[playerindex].DashPos=Players[playerindex].PlayerData.DashDistance;
			}
			else Players[playerindex].DashJump=FALSE;

		}


	}
}

