/*
	MegamanX: Odyssey
	Written by Sirk Siggler

*/
#include "../main.h"

char* CreateLayer( int xsize, int ysize )
{
	char* Layer;
	Layer=(char*)malloc( sizeof( char )*(xsize*ysize) );

	return Layer;
}

void ResizeLayer( int xsize, int ysize, char* layer )
{
	char* newlayer;
	newlayer=(char*)malloc( sizeof( char )*(xsize*ysize) );
	strcpy( newlayer, layer );
	free( layer );
	layer=newlayer;
}

void DestroyLayer( char* layer )
{
	free ( layer );
}

void DrawLayer( int camx, int camy, int xsize, int ysize )
{
	int x,y;
	int xoffset, yoffset;

	xoffset=(camx%32);
	yoffset=(camy%32);

	for ( x=0; x<xsize+2; x++ )
		for ( y=0; y<ysize+2; y++ )
		{
			if ( ((y+(camy/32))*mapxsize+(x+(camx/32))) > (mapxsize*mapysize) ||
				((y+(camy/32))*mapxsize+(x+(camx/32))) < 0 )
			{
				DrawTile( (x*32)-xoffset, (y*32)-yoffset, 0 );
			}
			else
			{
				DrawTile( (x*32)-xoffset, (y*32)-yoffset, EntityLayer[(y+(camy/32))*mapxsize+(x+(camx/32))] );
			}
		}

}

void DrawTile( int xpos, int ypos, int index )
{
	poly_hdr_t poly;
	vertex_ot_t vert;

	ta_poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565, 16, 16, TileBay[index], TA_NO_FILTER);
	ta_commit_poly_hdr(&poly);

	vert.r = vert.g = vert.b = 1.0f;
	//vert.a = 1.0f;
	//vert.oa = vert.or = vert.ob = 0.0f;
	vert.flags = TA_VERTEX_NORMAL;

	vert.x = xpos;
	vert.y = ypos;
	vert.z = 1;
	vert.u = 0.0;
	vert.v = 0.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = xpos+32;
	vert.y = ypos;
	vert.z = 1;
	vert.u = 1.0;
	vert.v = 0.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = xpos;
	vert.y = ypos+32;
	vert.z = 1;
	vert.u = 0.0;
	vert.v = 1.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = xpos+32;
	vert.y = ypos+32;
	vert.z = 1;
	vert.u = 1.0;
	vert.v = 1.0;
	vert.flags = TA_VERTEX_EOL;
	ta_commit_vertex(&vert, sizeof(vert));
}

void ChangeTile( int x, int y, int tileindex )
{
	if ( x < mapxsize && y < mapysize )
		EntityLayer[y*mapxsize+x]=tileindex;
}

void LoadMap( char* filename )
{
	unsigned int fd;

	fd=fs_open( filename, O_RDONLY );

	fs_read( fd, &mapxsize, sizeof(int) );
	fs_read( fd, &mapysize, sizeof(int) );

	EntityLayer=CreateLayer( mapxsize, mapysize );
	SlopeTable=CreateLayer( mapxsize, mapysize );

	fs_read( fd, EntityLayer, (mapxsize*mapysize)*sizeof(char) );
	fs_read( fd, SlopeTable, (mapxsize*mapysize)*sizeof(char) );

	fs_close(fd);
}