#include <kos.h>
#include "../main.h"

void DrawFrame( Animation Anim, int playerindex )
{
	if ( Players[playerindex].Facing == LEFT )
		DrawSprite( Anim.Frames[Players[playerindex].CurrentFrame],
			Players[playerindex].xpos-camerax, Players[playerindex].ypos-cameray,
			128, 128, TRUE );
	else
		DrawSprite( Anim.Frames[Players[playerindex].CurrentFrame],
			Players[playerindex].xpos-camerax, Players[playerindex].ypos-cameray,
			128, 128, FALSE );
}


void DrawSprite( int spriteindex, int xpos, int ypos, int xsize, int ysize, int flip )
{
	poly_hdr_t poly;
	vertex_ot_t vert;

	ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555, 64, 64, spriteindex, TA_NO_FILTER);
	ta_commit_poly_hdr(&poly);

	vert.flags = TA_VERTEX_NORMAL;
	vert.x = xpos-(xsize/2);
	vert.y = ypos-ysize;
	vert.z = 2;

	if ( flip == TRUE )
	{
		vert.u = 1.0;
		vert.v = 1.0;
	}
	else
		vert.u = 0.0;
		vert.v = 0.0;

	vert.dummy1 = vert.dummy2 = 0;
	vert.a = 1;
	vert.r = 1;
	vert.g = 1;
	vert.b = 1;
	vert.oa = vert.or = vert.og = vert.ob = 0.0f;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = xpos+(xsize/2);
	vert.y = ypos-ysize;

	if ( flip == TRUE )
	{
		vert.u = 0.0;
		vert.v = 1.0;
	}
	else
		vert.u = 1.0;
		vert.v = 0.0;

	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = xpos-(xsize/2);
	vert.y = ypos;

	if ( flip == TRUE )
	{
		vert.u = 1.0;
		vert.v = 0.0;
	}
	else
		vert.u = 0.0;
		vert.v = 1.0;

	ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_EOL;
	vert.x = xpos+(xsize/2);
	vert.y = ypos;

	if ( flip == TRUE )
	{
		vert.u = 0.0;
		vert.v = 0.0;
	}
	else
		vert.u = 1.0;
		vert.v = 1.0;

    ta_commit_vertex(&vert, sizeof(vert));
}

