#include <kos.h>
#include "../main.h"

void DrawBackground();
void DrawMenuCursor( int flip );

void UpdateScreen( int value1, int value2 )
{
	switch ( CurrentlyIn  )
	{
		case IN_MAP:
    		ta_begin_render();
   			DrawLayer( camerax, cameray, 20, 15 );
   			ta_commit_eol();
			DrawPlayers();
			ta_commit_eol();
    		ta_finish_frame();
    		break;
    	case IN_CHOOSEMENU:
    		ta_begin_render();
		   	DrawBackground();
		   	ta_commit_eol();
			//DrawMenuCursor( value1 );
			DrawSprite( MenuCursor, 320, 240, 64, 64, value1 );
			ta_commit_eol();
    		ta_finish_frame();
    		break;

	}
}

void DrawBackground()
{
	poly_hdr_t poly;
	vertex_ot_t vert;

	int xpos=0;
	int ypos=0;

	ta_poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565_TWID, 512, 512, MenuBackground, TA_BILINEAR_FILTER);
	ta_commit_poly_hdr(&poly);

	vert.r = vert.g = vert.b = 1.0f;
	vert.a = 1.0f;
	vert.oa = vert.or = vert.ob = 0.0f;
	vert.flags = TA_VERTEX_NORMAL;

	vert.x = 0;
	vert.y = 0;
	vert.z = 1;
	vert.u = 0.0;
	vert.v = 0.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = 640;
	vert.y = 0;
	vert.z = 1;
	vert.u = 1.0;
	vert.v = 0.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = 0;
	vert.y = 480;
	vert.z = 1;
	vert.u = 0.0;
	vert.v = 1.0;
	ta_commit_vertex(&vert, sizeof(vert));

	vert.x = 640;
	vert.y = 480;
	vert.z = 1;
	vert.u = 1.0;
	vert.v = 1.0;
	vert.flags = TA_VERTEX_EOL;
	ta_commit_vertex(&vert, sizeof(vert));
}