/*
	MegamanX: Odyssey
	Written by Sirk Siggler

*/
#include "../../main.h"

char* CreateLayer( int xsize, int ysize )
{
	char* Layer;
	Layer=(char*)malloc( sizeof( char )*(xsize*ysize) );

	return Layer;
}

void ResizeLayer( int xsize, int ysize, char* layer )
{
	char* newlayer;
	newlayer=(char*)malloc( sizeof( char )*(xsize*ysize) );
	strcpy( newlayer, layer );
	free( layer );
	layer=newlayer;
}

void DestroyLayer( char* layer )
{
	free ( layer );
}

void DrawLayer( unsigned char * layer, int camx, int camy, int xsize, int ysize )
{
	int x,y;
	int xoffset, yoffset;

	xoffset=(camx%32);
	yoffset=(camy%32);

	for ( x=0; x<xsize+1; x++ )
		for ( y=0; y<ysize+1; y++ )
		{
			if ( ((y+(camy/32))*mapxsize+(x+(camx/32))) > (mapxsize*mapysize) ||
				((y+(camy/32))*mapxsize+(x+(camx/32))) < 0 )
			{
				DrawTile( (x*32)-xoffset, (y*32)-yoffset, 0, 1 );
			}
			else
			{
				DrawTile( (x*32)-xoffset, (y*32)-yoffset, layer[(y+(camy/32))*mapxsize+(x+(camx/32))], 1 );
			}
		}

}

void DrawTile( int xpos, int ypos, int index, int scale )
{
	if ( xpos < 640 && ypos < 480)
	{
		draw_sprite( Buffer, TileBay[index], xpos, ypos );
	}
	else
	{
		//draw_sprite( Buffer, TileBay[index], xpos, ypos );
	}

	//stretch_sprite( TileBay[index], Buffer, xpos, ypos, 32*scale, 32*scale);
}

void ChangeTile( int x, int y, int tileindex )
{
	if ( x < mapxsize && y < mapysize )
		EntityLayer[y*mapxsize+x]=tileindex;
}

void LoadMap( char* filename )
{
	FILE* fd;

	fd=fopen( filename, "r" );

	fread( &mapxsize, sizeof(int), 1, fd );
	fread( &mapysize, sizeof(int), 1, fd );

	EntityLayer=CreateLayer( mapxsize, mapysize );
	ForegroundLayer=CreateLayer( mapxsize, mapysize );
	SlopeTable=CreateLayer( mapxsize, mapysize );

	fread( EntityLayer, (mapxsize*mapysize), sizeof(char), fd );
	fread( SlopeTable, (mapxsize*mapysize), sizeof(char), fd );
	fread( ForegroundLayer, (mapxsize*mapysize), sizeof(char), fd );

	fclose(fd);
}