#include <allegro.h>

spriteset CreateSpriteSet( int xsize, int ysize, int sprites )
{
	int i;
	spriteset s;
	s.xsize=xsize;
	s.ysize=ysize;
	s.numofsprites=sprites;

	for ( i=0; i<=sprites; i++ )
	{
		s.sprites[i]=create_bitmap( xsize, ysize );
	}

	return s;
}

void DestroySpriteSet( spriteset s )
{
	int i;

	for ( i=0; i<=s.numofsprites; i++ )
	{
		destroy_bitmap( s.sprites[i] );
	}

	s.numofsprites=0;
	s.xsize=0;
	s.ysize=0;
}

// Loads a series of PCX file instead of a SET, will be fixed later...
spriteset LoadSpriteSet( char * filename )
{
	int i,x,y,xsize,ysize,amount;
	spriteset s;
	FILE* SETfile;
	unsigned char r,g,b;
	char tempstr[100];


	SETfile=fopen( filename, "rb" );

	fread( &amount, sizeof(int), 1, SETfile );
	fread( &xsize, sizeof(int), 1, SETfile );
	fread( &ysize, sizeof(int), 1, SETfile );

	s=CreateSpriteSet( xsize, ysize, amount );

	for ( i=0; i<=amount; i++ )
	{
		// Read in an image....
		for ( x=0; x<xsize; x++ )
			for ( y=0; y<ysize; y++ )
			{
				fread( &r, 1, 1, SETfile );
				fread( &g, 1, 1, SETfile );
				fread( &b, 1, 1, SETfile );
				putpixel( s.sprites[i], x, y, makecol( r, g, b ) );
			}

	}
	fclose(SETfile);

	return s;
}