unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, DXDraws, DXClass, StdCtrls, DIB, Spin, ComCtrls,
  ToolWin, Buttons;

type
  TForm1 = class(TDXForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Exit: TMenuItem;
    TestMap: TMenuItem;
    MAP1: TMenuItem;
    LoadMAP: TMenuItem;
    LE1: TMenuItem;
    LoadTLE: TMenuItem;
    Panel2: TPanel;
    DXDraw: TDXDraw;
    TileBay: TDXImageList;
    Panel3: TPanel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    OpenMapDlg: TOpenDialog;
    OpenTleDlg: TOpenDialog;
    Panel4: TPanel;
    Panel5: TPanel;
    Image1: TImage;
    StatusBar: TStatusBar;
    DrawUpon: TComboBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Options1: TMenuItem;
    EditPanelLocation1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Information1: TMenuItem;
    TileSlot1: TDXDraw;
    TileSlot2: TDXDraw;
    SaveMap1: TMenuItem;
    SaveMapDlg: TSaveDialog;
    ileSize1: TMenuItem;
    N16: TMenuItem;
    N32: TMenuItem;
    N64: TMenuItem;
    BackgroundColor1: TMenuItem;
    White1: TMenuItem;
    Black1: TMenuItem;
    Other1: TMenuItem;
    ImageList: TDXImageList;
    ColorDialog1: TColorDialog;
    Button1: TButton;
    NewMap1: TMenuItem;
    NewTLE1: TMenuItem;
    SaveTLE1: TMenuItem;
    CloseMap1: TMenuItem;
    Panel1: TPanel;
    TileBox: TDXDraw;
    ScrollBar3: TScrollBar;
    procedure ExitClick(Sender: TObject);
    procedure LoadMAPClick(Sender: TObject);
    procedure LoadTLEClick(Sender: TObject);
    procedure DrawTile( surface: TDirectDrawSurface; xpos: integer; ypos: integer; index: byte );
    procedure FormCreate(Sender: TObject);
    procedure DrawMap( xpos: integer; ypos:integer );
    procedure DrawTileBox( position: integer );
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure UpdateGUIObjects();
    procedure DrawTileSlots();
    procedure Image1Click(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ChangeTile( xpos,ypos: integer; index: integer );
    procedure DXDrawMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DXDrawMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DXDrawMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TileBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TileBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TileBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Information1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure SaveMap1Click(Sender: TObject);
    procedure White1Click(Sender: TObject);
    procedure Black1Click(Sender: TObject);
    procedure Other1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N32Click(Sender: TObject);
    procedure N64Click(Sender: TObject);
    procedure NewMap1Click(Sender: TObject);
    procedure CloseMap1Click(Sender: TObject);
    procedure SetMapLoaded();
    procedure SetMapClosed();
    procedure SetTleLoaded();
    procedure SetTleClosed();
  private
    { Private declarations }
  public
    EntityLayer: array of Byte;
    SlopeTable: array of Byte;
    ForegroundLayer: array of Byte;
    mapxsize,mapysize: integer;
    slot1,slot2: integer;
    tileboxpos: integer;
    MapMouseX,MapMouseY:integer;
    TileBoxMouseOver: integer;
    mousebLeft,mousebRight: boolean;
  end;

var
  Form1: TForm1;
  maploaded:boolean = false;
  tleloaded:boolean = false;
  bgcolor: integer = clwhite;
  tilesize: integer = 16;

implementation

uses Unit2, Unit3, Unit4;

{$R *.dfm}

procedure TForm1.ExitClick(Sender: TObject);
begin
application.terminate;
end;

procedure TForm1.LoadMAPClick(Sender: TObject);
var
fd: tfilestream;
filename: string;
xsize: integer;
ysize: integer;
size: integer;
i: integer;
begin

if OpenMapDlg.execute then
begin
filename:=OpenmapDlg.FileName;
Fd:=TFileStream.Create( filename ,fmOpenRead );

Fd.Read(xsize,SizeOf(integer));
Fd.Read(ysize,SizeOf(integer));
size:=xsize*ysize;

SetLength( EntityLayer, size );
SetLength( Slopetable, size );
SetLength( Foregroundlayer, size );

for i:=0 to size-1 do
Fd.Read(EntityLayer[i],sizeof(Byte));
for i:=0 to size-1 do
Fd.Read(SlopeTable[i],sizeof(Byte));
for i:=0 to size-1 do
Fd.Read(ForegroundLayer[i],sizeof(Byte));

fd.free;

//scrollbar2.max:=ysize;
//scrollbar1.Max:=xsize;

mapxsize:=xsize;
mapysize:=ysize;

SetMapLoaded();
statusbar.panels[0].text:=ExtractFilename( filename );

scrollbar1.Max:=(mapxsize*tilesize)-(dxdraw.width);
scrollbar2.Max:=(mapysize*tilesize)-(dxdraw.Height);
UpdateGUIObjects();
end;
end;

procedure TForm1.LoadTLEClick(Sender: TObject);
var
F: TFileStream;
filename: string;
r: byte;
g: byte;
b: byte;
x: integer;
y: integer;
i: integer;
dib: TDib;
Item: TPictureCollectionItem;
begin
dib:=tdib.create;
dib.assign( TileBay.items[0].Picture );

if OpenTleDlg.Execute then
begin
filename := OpenTleDlg.FileName;
F := TFileStream.Create( filename ,fmOpenRead );

for I:=0 to 255 do
begin
        for X:=0 to 15 do
        for Y:=0 to 15 do
        begin
        F.Read(r,SizeOf(Byte));
        F.Read(g,SizeOf(Byte));
        F.Read(b,SizeOf(Byte));
        dib.pixels[x,y]:=RGB( r, g, b );
        end;
        item:=TileBay.items[0];
        Item.Picture.Graphic := dib;
        TileBay.items[i].assign( item );
end;
F.free;
end;
Statusbar.Panels[1].text:=ExtractFileName(filename);
UpdateGUIObjects();
end;

procedure TForm1.DrawTile( surface: TDirectDrawSurface; xpos: integer; ypos: integer; index: byte );
var
rect32: TRect;
rect64: TRect;
begin
rect32.Top:=ypos;
rect32.Left:=xpos;
rect32.Bottom:=ypos+32;
rect32.right:=xpos+32;

rect64.Top:=ypos;
rect64.Left:=xpos;
rect64.Bottom:=ypos+64;
rect64.right:=xpos+64;

//if index < 256 then
begin
TileBay.items[ord(index)].transparent:=true;
if tilesize = 16 then
TileBay.items[ord(index)].Draw( surface, xpos, ypos, 0 )
else if tilesize = 32 then
TileBay.items[ord(index)].StretchDraw( surface, rect32, 0 )
else if tilesize = 64 then
TileBay.items[ord(index)].StretchDraw( surface, rect64, 0 );
TileBay.items[ord(index)].transparent:=false;
end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
I: integer;
begin
scrollbar2.Top:=1;
scrollbar2.Left:=panel2.Width-16;
scrollbar2.height:=panel2.height-17;

scrollbar1.Top:=panel2.Height-16;
scrollbar1.Left:=1;
scrollbar1.width:=panel2.width-17;

dxdraw.top:=0;
dxdraw.left:=0;
dxdraw.Height:=panel2.Height-17;
dxdraw.Width:=panel2.Width-17;

DXDraw.ColorTable := TileBay.Items.ColorTable;
DXDraw.DefColorTable := TileBay.Items.ColorTable;
DXDraw.UpdatePalette;

button1.Left:=panel2.Width-16;
button1.top:=panel2.height-16;

for i:=0 to 255 do
begin
TileBay.Items.add;
Tilebay.items[i].assign( Tilebay.Items[0] );
end;
slot1:=0;
slot2:=1;

UpdateGUIObjects();
end;

procedure TForm1.DrawMap( xpos: integer; ypos:integer );
var
x: integer;
y: integer;
width: integer;
height: integer;
xoffset,yoffset: integer;
begin
height:=dxdraw.Height div tilesize;
width:=dxdraw.Width div tilesize;
xoffset:=(scrollbar1.position mod tilesize);
yoffset:=(scrollbar2.position mod tilesize);

dxdraw.Surface.Fill( bgcolor );
if maploaded = true then
for x:=0 to width+1 do
for y:=0 to height+1 do
begin

if (y+(scrollbar2.position div tilesize )*mapxsize+(x+(scrollbar1.position div tilesize ))) > (mapxsize*mapysize) then
DrawTile( dxdraw.surface, (x*tilesize)-xoffset, (y*tilesize)-yoffset, 0 )
else if ((y+(scrollbar2.Position div tilesize ))*mapxsize+(x+(scrollbar1.position div tilesize ))) < 0  then
DrawTile( dxdraw.surface, (x*tilesize)-xoffset, (y*tilesize)-yoffset, 0 )
else
begin
if checkbox1.checked = true then
DrawTile( dxdraw.surface, (x*tilesize)-xoffset, (y*tilesize)-yoffset, EntityLayer[(y+(scrollbar2.position div tilesize))*mapxsize+(x+(scrollbar1.position div tilesize))] );
if checkbox2.Checked = true then
DrawTile( dxdraw.surface, (x*tilesize)-xoffset, (y*tilesize)-yoffset, ForegroundLayer[(y+(scrollbar2.position div tilesize))*mapxsize+(x+(scrollbar1.position div tilesize))] );
end;

// Old map draw code..
{for x:=0 to width do
for y:=0 to height do
begin
if checkbox1.Checked = true then
DrawTile( dxdraw.surface, x*16, y*16, EntityLayer[(y+ypos)*mapxsize+(x+xpos)] );

if checkbox2.Checked = true then
DrawTile( dxdraw.surface, x*16, y*16, ForegroundLayer[(y+ypos)*mapxsize+(x+xpos)] );
end; }

end;
dxdraw.flip;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
UpdateGUIObjects();
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
UpdateGUIObjects();
end;

procedure TForm1.DrawTileBox( position: integer );
var
I: integer;
width: integer;
rect: TRect;
begin
width:=(tilebox.Width) div 32;
TileBox.Surface.Fill( dxdraw.surface.ColorMatch(clBtnFace) );
for i:=0 to width do
begin
rect.Top:=0; rect.Left:=i*32; rect.right:=(i*32)+32; rect.Bottom:=32;
TileBay.Items[(position)+i].stretchdraw( TileBox.surface, rect, 0 );
end;

Tilebox.flip;
end;

procedure TForm1.DrawTileSlots();
var
rect: TRect;
begin
rect.Top:=0; rect.Left:=0; rect.Bottom:=32; rect.Right:=32;
TileBay.items[slot1].StretchDraw( TileSlot1.surface, rect, 0 );
TileBay.items[slot2].StretchDraw( TileSlot2.surface, rect, 0 );
Tileslot1.flip;
Tileslot2.flip;
end;

procedure TForm1.UpdateGUIObjects();
begin
//showmessage( 'Update!' );
DrawMap( scrollbar1.position, scrollbar2.position );
DrawTileSlots();
DrawTileBox( tileboxpos );

if maploaded = true then
begin
scrollbar1.Max:=(mapxsize*tilesize)-(dxdraw.width);
scrollbar2.Max:=(mapysize*tilesize)-(dxdraw.Height);
end;
end;

procedure TForm1.Image1Click(Sender: TObject);
var
slot1old,slot2old: integer;
begin
slot1old:=slot1;
slot2old:=slot2;
slot1:=slot2old;
slot2:=slot1old;

UpdateGUIObjects();
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
tileboxpos:=scrollbar3.Position;
UpdateGUIObjects();
end;

procedure TForm1.Left1Click(Sender: TObject);
begin
left1.checked:=true;
right1.checked:=false;
panel3.Align:=alLeft;
end;

procedure TForm1.Right1Click(Sender: TObject);
begin
left1.checked:=false;
right1.checked:=true;
panel3.Align:=alRight;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
scrollbar2.Top:=1;
scrollbar2.Left:=panel2.Width-16;
scrollbar2.height:=panel2.height-17;

scrollbar3.Max:=256-(tilebox.Width div 32);

scrollbar1.Top:=panel2.Height-16;
scrollbar1.Left:=1;
scrollbar1.width:=panel2.width-17;

dxdraw.top:=0;
dxdraw.left:=0;
dxdraw.Height:=panel2.Height-17;
dxdraw.Width:=panel2.Width-17;

button1.Left:=panel2.Width-16;
button1.top:=panel2.height-16;

TileBox.width:=panel1.width-8;
scrollbar3.Width:=panel1.width-8;

UpdateGUIObjects();
end;

procedure TForm1.ChangeTile( xpos,ypos: integer; index: integer );
begin
if maploaded = true then
begin
if DrawUpon.text = 'EntityLayer' then
        if EntityLayer[ypos*mapxsize+xpos] <> index then
        begin
        EntityLayer[ypos*mapxsize+xpos]:=index;
        UpdateGUIObjects();
        end
else if DrawUpon.text = 'Foreground' then
        if ForegroundLayer[ypos*mapxsize+xpos] <> index then
        begin
        ForegroundLayer[ypos*mapxsize+xpos]:=index;
        UpdateGUIObjects();
        end;
end;
end;

procedure TForm1.DXDrawMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
MapMouseX:=(X div tilesize)+(scrollbar1.position div tilesize );
MapMouseY:=(Y div tilesize)+(scrollbar2.position div tilesize );
statusbar.Panels[2].text:=format( '(%d,%d)', [MapMouseX, MapMouseY] );

if (mousebLeft = true) then
begin
        if DrawUpon.text = 'EntityLayer' then
        ChangeTile( MapMouseX, MapMouseY, slot1 )
        else if DrawUpon.Text = 'Foreground' then
        ChangeTile( MapMouseX, MapMouseY, slot1 );
end
else if (mousebRight = true ) then
begin
        if DrawUpon.text = 'EntityLayer' then
        ChangeTile( MapMouseX, MapMouseY, slot2 )
        else if DrawUpon.Text = 'Foreground' then
        ChangeTile( MapMouseX, MapMouseY, slot2 );
end;
end;

procedure TForm1.DXDrawMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then
mousebLeft:=true;

if button=mbRight then
mousebRight:=true;

if (mousebLeft = true) then
begin
        if DrawUpon.text = 'EntityLayer' then
        ChangeTile( MapMouseX, MapMouseY, slot1 )
        else if DrawUpon.Text = 'Foreground' then
        ChangeTile( MapMouseX, MapMouseY, slot1 );
end
else if (mousebRight = true ) then
begin
        if DrawUpon.text = 'EntityLayer' then
        ChangeTile( MapMouseX, MapMouseY, slot2 )
        else if DrawUpon.Text = 'Foreground' then
        ChangeTile( MapMouseX, MapMouseY, slot2 );
end;

end;

procedure TForm1.DXDrawMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then
mousebLeft:=false;

if button=mbRight then
mousebRight:=false;
end;

procedure TForm1.TileBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
tilex,tiley: integer;
begin

tilex:=X div 32;
tiley:=Y div 32;
TileBoxMouseOver:=(tileboxpos)+tilex;
StatusBar.panels[3].text:=format( '%d', [TileBoxMouseOver] );

if mousebLeft = true then
begin
        if TileBoxMouseOver > 0 then
        if TileBoxMouseOver < 255 then
        begin
        Slot1:=TileBoxMouseOver;
        UpdateGUIObjects();
        end;
end
else if mousebRight = true then
begin
Slot2:=TileBoxMouseOver;
UpdateGUIObjects();
end;
end;

procedure TForm1.TileBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then
mousebLeft:=true;

if button=mbRight then
mousebRight:=true;

if mousebLeft = true then
begin
        if TileBoxMouseOver > 0 then
        if TileBoxMouseOver < 255 then
        begin
        Slot1:=TileBoxMouseOver;
        UpdateGUIObjects();
        end;
end
else if mousebRight = true then
begin
Slot2:=TileBoxMouseOver;
UpdateGUIObjects();
end;
end;

procedure TForm1.TileBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then
mousebLeft:=false;

if button=mbRight then
mousebRight:=false;
end;

procedure TForm1.Information1Click(Sender: TObject);
begin
form2.ShowModal();
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
UpdateGUIObjects();
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
UpdateGUIObjects();
end;

procedure TForm1.SaveMap1Click(Sender: TObject);
var
fd: tfilestream;
filename: string;
size: integer;
i: integer;
begin

if SaveMapDlg.execute then
begin
filename:=SaveMapDlg.FileName;
Fd:=TFileStream.Create( filename ,fmCreate );

Fd.Write(mapxsize,SizeOf(integer));
Fd.Write(mapysize,SizeOf(integer));
size:=mapxsize*mapysize;

for i:=0 to size-1 do
Fd.write(EntityLayer[i],sizeof(Byte));
for i:=0 to size-1 do
Fd.write(SlopeTable[i],sizeof(Byte));
for i:=0 to size-1 do
Fd.write(ForegroundLayer[i],sizeof(Byte));

fd.free;

end;
end;

procedure TForm1.White1Click(Sender: TObject);
begin
bgcolor:=clWhite;
UpdateGUIObjects();
white1.checked:=true;
black1.checked:=false;
other1.Checked:=false;
end;

procedure TForm1.Black1Click(Sender: TObject);
begin
bgcolor:=clBlack;
UpdateGUIObjects();
black1.checked:=true;
white1.checked:=false;
other1.Checked:=false;
end;

procedure TForm1.Other1Click(Sender: TObject);
begin
if ColorDialog1.execute then
begin
bgcolor:=dxdraw.surface.ColorMatch(colordialog1.color);
white1.checked:=false;
black1.checked:=false;
other1.checked:=true;
UpdateGUIObjects();
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
form3.showmodal;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
UpdateGUIObjects();
end;

procedure TForm1.N16Click(Sender: TObject);
begin
tilesize:=16;
N16.checked:=true;
N32.checked:=false;
N64.checked:=false;
UpdateGUIObjects();
end;

procedure TForm1.N32Click(Sender: TObject);
begin
tilesize:=32;
N16.checked:=false;
N32.checked:=true;
N64.checked:=false;
UpdateGUIObjects();
end;

procedure TForm1.N64Click(Sender: TObject);
begin
tilesize:=64;
N16.checked:=false;
N32.checked:=false;
N64.checked:=true;
UpdateGUIObjects();
end;

procedure TForm1.NewMap1Click(Sender: TObject);
begin
form4.showmodal;
SetMapLoaded();
end;

procedure TForm1.CloseMap1Click(Sender: TObject);
begin
SetMapClosed();

setlength( entitylayer, 0 );
setlength( slopetable, 0 );
setlength( foregroundlayer, 0 );
mapxsize:=0;
mapysize:=0;
end;

procedure TForm1.SetMapLoaded();
begin
maploaded:=true;
checkbox1.Enabled:=true;
checkbox2.Enabled:=true;
DrawUpon.enabled:=true;
end;

procedure TForm1.SetMapClosed();
begin
maploaded:=false;
checkbox1.Enabled:=false;
checkbox2.Enabled:=false;
DrawUpon.enabled:=false;
end;

procedure TForm1.SetTleLoaded();
begin
//
end;

procedure TForm1.SetTleClosed();
begin
//
end;

end.

