/*
	Dir2TLE
	Written by Sirk Siggler

*/
#include <allegro.h>
#include "tle.h"

int main()
{
	BITMAP* tempbmp;
	FILE* TLEfile;
	char Filename[100];
	int Done=FALSE;
 	int i,x,y;
	unsigned char r,g,b;
	x=y=0;

	allegro_init();
	install_keyboard();
	install_timer();

	set_color_depth( 16 );
	if ( set_gfx_mode( GFX_DIRECTX, 640, 480, 0, 0 ) < 0 )
	{
		set_color_depth( 15 );
		set_gfx_mode( GFX_DIRECTX, 640, 480, 0, 0 );
	}

	tempbmp=create_bitmap( 16, 16 );
	TLEfile=fopen( "output.tle", "wb" );

	/* Write tile 0. The blank trans. tile */
	for ( x=0; x<256; x++ )
	{
		r=255; g=0; b=255;
		fwrite( &r, 1, 1, TLEfile );
		fwrite( &g, 1, 1, TLEfile );
		fwrite( &b, 1, 1, TLEfile );
	}

	i=0;
	while ( Done!=TRUE )
	{
		sprintf( Filename, "%i.pcx", i );
		if ( !exists( Filename ) )
			Done=TRUE;
    	else
		{
			tempbmp=load_pcx( Filename, NULL );

			for ( x=0; x<16; x++ )
				for ( y=0; y<16; y++ )
				{
					r=getr( getpixel( tempbmp, x, y ) );
					g=getg( getpixel( tempbmp, x, y ) );
					b=getb( getpixel( tempbmp, x, y ) );
					fwrite( &r, 1, 1, TLEfile );
					fwrite( &g, 1, 1, TLEfile );
					fwrite( &b, 1, 1, TLEfile );
				}
			i++;
		}
	}
	fclose(TLEfile);
}
END_OF_MAIN();